#include <stdio.h>
#include <stdlib.h>

#define PAGE_SHIFT 12

int main(int argc, char** argv) {
  if (argc < 3) {
    printf("bad args\n");
    exit(EXIT_FAILURE);
  }

  uint64_t meta_page_base = strtoull(argv[1], NULL, 0);
  uint64_t alloc = strtoull(argv[2], NULL, 0);

  uint32_t packed_address = (uint32_t)(((int64_t)alloc) >> PAGE_SHIFT);

  printf("alloc: %016llx\n", alloc);
  printf("packed: %08x\n", packed_address);
  
  uint64_t page_meta = meta_page_base + (16*(uint64_t)packed_address);
  printf("page_meta: 0x%016llx\n", page_meta);

  return 0;
}
